#!/usr/bin/ruby -Ke


ARGV.each do |file|
  prototype = []

  unless file =~ /^.*\.c$/
    print "#{file} is not a C source file.\n"
    next
  end
  File.open(file, "r") do |f|
    f.each do |line|
      if line =~ /^[A-z].*\(/ and line !~ /static/ and line !~ /[A-Z]{3,}/ and line !~ /typedef/
	line.chop!
	line.concat ";\n"
	prototype << line
      end
    end
  end

  out = File.open("tmp.#{$$}", "w")
  file.gsub!(/\.c$/, ".h")
  File.open(file, "r") do |input|
    while line = input.gets
      if line =~ /\/\* PROTOTYPE_BEGIN \*\//
	out.print line
	while line = input.gets
	  if line =~ /\/\* PROTOTYPE_END \*\//
	    break
	  end
	end
	prototype.each do |str|
	  out.print str
	end
	out.print line
      else
      out.print line
      end
    end
  end
  out.close

  File.rename(file, "#{file}~")
  File.rename("tmp.#{$$}", file)
end
	
