#ifndef T_DRAWER_H
#define T_DRAWER_H
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "geometry.h"

typedef struct {
	XOC oc;
	XOC oc2;
	XOM om;
	Display *display;
	Window window;
	int screen;
	GC gc;
	Atom protocols;

	int font_width;
	int font_height;

	XRectangle ext;
} t_drawer;

/* PROTOTYPE_BEGIN */
int t_drawer_define_cursor(t_drawer *self, unsigned int shape);
int t_drawer_undefine_cursor(t_drawer *self);
int t_drawer_set_font(t_drawer *self, char *fontname, XOrientation orientation);
geometry *t_drawer_get_text_extents(t_drawer *self, wchar_t *text, int len);
geometry *t_drawer_get_text_extents2(t_drawer *self, wchar_t *text, int len);
t_drawer *t_drawer_new(int global_length, int line_length, char *fontname);
void t_drawer_draw_string(t_drawer *self, int global_pt, int local_pt, wchar_t *str, int len);
void t_drawer_draw_string2(t_drawer *self, int global_pt, int local_pt, wchar_t *str, int len);
void t_drawer_get_next_event(t_drawer *self, XEvent *event);
void t_drawer_destroy(t_drawer *self);
void t_drawer_clear(t_drawer *self);
void t_drawer_copy_area(t_drawer *self, int src_x, int src_y, int width, int height, int dest_x, int dest_y);
void t_drawer_clear_area(t_drawer *self, int x, int y, int width, int height, Bool exposures);
/* PROTOTYPE_END */

#endif
