#ifndef T_SCREEN_H
#define T_SCREE_H
#include "line.h"
#include "t_drawer.h"

#define DEFAULT_FONT "-kappa-fixed-medium-r-normal--20-*-*-*-vc-*-*-*,-kappa-fixed-medium-r-normal--20-*-*-*-*-*-*-*,*"
//#define DEFAULT_FONT "a14,r14,k14"
//#define DEFAULT_FONT "-kappa-fixed-medium-r-normal--20-*-*-*-vc-*-*-*,-adobe-times-medium-r-normal--20-*-*-*-*-*-*-*"

typedef struct {
	t_drawer *drawer;

	line **lines;
	int nlines;		/* 礭 */
	int focus_pos;		/* ϲܤФź˻Ȥ */

	geometry *geo;

	geometry *next_pos;


	geometry *screen_geo;

	int grabbed;
	int grab_x;
	int grab_y;
} t_screen;


/* PROTOTYPE_BEGIN */
char lastchar(const char *str);
int is_encoding(char *input, char *encoding);
char *determine_codeset(char *input);
void strchop(char *str);
char *codeset_of_file(const char *filename);
void t_screen_add_line(t_screen *self, line *new);
t_screen *t_screen_new(const char *filename, int global_length, int line_length);
void t_screen_calc_geometry(t_screen *self, int shinkou);
void t_screen_free(t_screen *self);
geometry *t_screen_xexpose_to_geometry(t_screen *self, XExposeEvent *e);
void t_screen_main(t_screen *self);
void t_screen_expose_callback(t_screen *self, geometry *area_to_redraw);
void t_screen_scroll_left(t_screen *self, int width);
void t_screen_scroll_right(t_screen *self, int width);
void t_screen_jump_to(t_screen *self, int chokkaku_pos);
/* PROTOTYPE_END */

#endif

