#include <X11/Xlib.h>

#include "tategaki.h"

#include <locale.h>

#include "t_screen.h"

Bool tate_chu_yoko_mode = True;
char *appname;
int locale_eucjp_p;

static int is_locale_eucjp_p(const char *locale)
{
	static const char *locales[] = { "ja_JP.eucJP", "ja_JP.ujis", "ja_JP.EUC", "ja", "japanese", "japanese.EUC", NULL };
	int i;
	char *current = setlocale(LC_CTYPE, NULL);

	for (i = 0; locales[i] != NULL; i++) {
		if (strcmp(current, locales[i]) == 0) {
			return locale_eucjp_p = 1;
		}
	}
	return locale_eucjp_p = 0;
}

static void usage(void)
{
	fprintf(stderr, "Usage: %s [options] [filename]\n", appname);
	fprintf(stderr, "Options:\n\t-n\tdisable tate-chu-yoko feature.\n");
}

int main(int argc, char *argv[])
{
	t_screen *screen;
	char *filename;

	setlocale(LC_ALL, "");
	if (!is_locale_eucjp_p(setlocale(LC_CTYPE, ""))) {
		fprintf(stderr, "Current locale(%s) has the character type other than EUC-JP. Kinsoku-Shori turned off.\n", setlocale(LC_CTYPE, ""));
	}

	appname = argv[0];

        while (1) {
                int c = getopt(argc, argv, "n");

                if (c == -1)
                        break;
                switch (c) {
                case 'n':
                        tate_chu_yoko_mode = False;
                        break;
                default:
                        usage();
                }
        }
        if (optind < argc) {
                filename = argv[optind++];
                while (optind < argc) {
                        fprintf(stderr, "extra filename %s ignored.\n", argv[optind++]);
                }
	} else {
		usage();
		exit(1);
	}

	screen = t_screen_new(filename, 640, 480);
	t_screen_calc_geometry(screen, 480);
	t_screen_main(screen);

	return 0;
}
